<?php
// +--------------------------------------------------------------------------+
// | Contentteller(R) Community Edition 1.0.0 (Release Candidate 2)           |
// +--------------------------------------------------------------------------+
// | Copyright (C) 2002 - 2008 by Esselbach Internet Solutions                |
// | Available from http://www.contentteller.com                              |
// +--------------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or modify it  |
// | under the terms of the GNU General Public License version 3 as published |
// | by the Free Software Foundation.                                         |
// |                                                                          |
// | This program is distributed in the hope that it will be useful, but      |
// | WITHOUT ANY WARRANTY; without even the implied warranty of               |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. For more details    |
// | see the GNU General Public License.                                      |
// |                                                                          |
// | You should have received a copy of the GNU General Public License along  |
// | with this program; if not, see http://www.gnu.org/licenses or write to   |
// | the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,     |
// | Boston, MA 02110-1301 USA.                                               |
// |                                                                          |
// | You can contact Esselbach Internet Solutions at the following address:   |
// | Rautenstrauchgasse 6-16/4, A-1110 Vienna, Austria                        |
// | or via email at office (at) esselbach.com                                |
// |                                                                          |
// | The interactive user interfaces in modified source and object code       |
// | versions of this program must display Appropriate Legal Notices,         |
// | as required under Section 5 of the GNU General Public License version 3. |
// | In accordance with Section 7(b) of the GNU General Public License        |
// | version 3, these Appropriate Legal Notices must retain the display of    |
// | the "Managed with Contentteller" logo and retain the original            |
// | copyright notice.                                                        |
// |                                                                          |
// | If the display of the logos are not reasonably feasible for technical    |
// | reasons, the Appropriate Legal Notices must display the words "Managed   |
// | with Contentteller"                                                      |
// +--------------------------------------------------------------------------+
// | Contentteller is a registered trademark.                                 |
// +--------------------------------------------------------------------------+ 
// | Build: 499.1 Date: Wed, 20 Aug 2008 15:28:54 +0200                       |  
// +--------------------------------------------------------------------------+

/**
 * @package Contentteller
 * @subpackage Templates
 * @copyright (C) 2002-2008 Esselbach Internet Solutions
 */

/**
 * function AdminDoUpdateSet
 * A function to update a template set from HTML/PHP files 
 * @author Philipp Louis Esselbach
 */
function AdminDoUpdateSet()
{
	global $database, $security, $preferences, $html, $system, $ipaddr, $words_templates;
	$input_import_set = ( isset( $_POST[ 'input_import_set' ] ) ) ? $security -> checknum( $_POST[ 'input_import_set' ] ) : "" ;
	$input_security_hash = ( isset( $_POST[ 'input_security_hash' ] ) ) ? $security -> checkvar( $_POST[ 'input_security_hash' ] ) : "" ;

	if( ( $system -> adminhashget() != $input_security_hash ) and( $preferences[ 'website_subsessions_admin' ] ) )
	{
		$html -> login( $words_templates[ 'ERROR' ], $words_templates[ 'INVALID_SESSION' ], "index.php" );
		exit;
	}
	
	$template_current_date = mktime();
	$html -> makeheader( $words_templates[ 'UPDATING_TEMPLATES' ] );
	$html -> makesubheader();
	$html -> makegroupmenu( "templates" );
	$html -> makemainheader( $words_templates[ 'UPDATING_TEMPLATES' ], "update" );
	echo $words_templates[ 'UPDATING_TEMPLATES_FROM' ] . "<br />";
	
	if( file_exists( "../templates/style.css" ) )
	{
		$templateset_css_file = fopen( "../templates/style.css", "r" );
		$templateset_css = fread( $templateset_css_file, filesize( "../templates/style.css" ) );
		fclose( $templateset_css_file );
	}
	else
	{
		$templateset_css = "";
	}
	if ( $templateset_css )
	{
		$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_templatesets SET templateset_css = '" . $database -> dbescape( $templateset_css ) . "' WHERE templateset_id = '" . $input_import_set . "'" );
		echo "style.css " . $words_templates[ 'UPDATING' ] . "<br />";
	}
	
	if( file_exists( "../templates/style.data" ) )
	{
		$templateset_data_file = fopen( "../templates/style.data", "r" );
		$templateset_data = fread( $templateset_data_file, filesize( "../templates/style.data" ) );
		fclose( $templateset_data_file );
		$style_data = explode( "/", $templateset_data );
		$templateset_style = $style_data[ 1 ];
		$templateset_usecss = $style_data[ 0 ];
	}
	else
	{
		$templateset_style = "";
		$templateset_usecss = 0;
	}	
	if ( $templateset_style )
	{
		$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_templatesets SET templateset_style = '" . $database -> dbescape( $templateset_style ) . "', templateset_usecss = '" . $database -> dbescape( $templateset_usecss ) . "' WHERE templateset_id = '" . $input_import_set . "'" );
		echo "style.data " . $words_templates[ 'UPDATING' ] . "<br />";
	}
		
	$templates_dir = $system -> getdir( "../templates" );
	
	for( $i = 1; $i < count( $templates_dir ); $i++ )
	{
		if( preg_match( "/html/i", $templates_dir[ $i ] ) )
		{
			$truefile = explode( ".", $templates_dir[ $i ] );
			
			if( file_exists( "../templates/" . $truefile[ 0 ] . ".html" ) )
			{
				$template_html = "";
				$template_php = "";
				$template_date = mktime();
				$template_html_file = fopen( "../templates/" . $truefile[ 0 ] . ".html", "r" );
				$template_html = fread( $template_html_file, filesize( "../templates/" . $truefile[ 0 ] . ".html" ) );
				fclose( $template_html_file );
				
				if( file_exists( "../templates/" . $truefile[ 0 ] . ".date" ) )
				{
					$template_date_file = fopen( "../templates/" . $truefile[ 0 ] . ".date", "r" );
					$template_date = fread( $template_date_file, filesize( "../templates/" . $truefile[ 0 ] . ".date" ) );
					fclose( $template_date_file );
				}
				
				if( file_exists( "../templates/" . $truefile[ 0 ] . ".php" ) )
				{
					$template_php_file = fopen( "../templates/" . $truefile[0] . ".php", "r" );
					$template_php = fread( $template_php_file, filesize( "../templates/" . $truefile[ 0 ] . ".php" ) );
					fclose( $template_php_file );
				}
				
				$template_php = $database -> dbescape( $template_php );
				$template_html = $database -> dbescape( $template_html );
				echo $truefile[ 0 ];
				$query = $database -> dbquery( "SELECT * FROM " . DB_PREFIX . "esselbach_ct_templates WHERE template_name = '" . $truefile[ 0 ] . "' and template_set = '" . $input_import_set . "'" );
				
				if( $database -> dbrows( $query ) )
				{
					if( $preferences[ 'templates_undo' ] )
					{					
						$query = $database -> dbquery( "SELECT template_id, template_html, template_php, template_date FROM " . DB_PREFIX . "esselbach_ct_templates WHERE template_name = '" . $truefile[ 0 ] . "' and template_set = '" . $input_import_set . "'" );
						list( $old_template_id, $old_template_html, $old_template_php, $old_template_edit_date ) = $database -> dbrow( $query );
						$old_template_html = $database -> dbescape( $old_template_html );
						$old_template_php = $database -> dbescape( $old_template_php );
						$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_templatesundo (templateundo_id, templateundo_template, templateundo_html, templateundo_php, templateundo_date, templateundo_ip, templateundo_editreason) VALUES (NULL, '" . $old_template_id . "', '" . $old_template_html . "', '" . $old_template_php . "', '" . $old_template_edit_date . "', '" . $ipaddr . "', '" . $database -> dbescape( $words_templates[ 'UPDATED_FROM_DIRECTORY' ] ) . "')" );
					}
					$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_templates SET template_html = '" . $template_html . "', template_php = '" . $template_php . "', template_editreason = '" . $database -> dbescape( $words_templates[ 'UPDATED_FROM_DIRECTORY' ] ) . "', template_date = '" . $template_current_date . "', template_editip = '" . $ipaddr . "' WHERE template_name = '" . $truefile[ 0 ] . "' AND template_set = '" . $input_import_set . "'" );
					echo " " . $words_templates[ 'UPDATING' ] . "<br />";
				}
				else
				{
					$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_templates (template_id, template_set, template_name, template_html, template_php, template_date, template_postip, template_editip, template_editreason) VALUES (NULL, '" . $input_import_set . "', '" . $truefile[ 0 ] . "', '" . $template_html . "', '" . $template_php . "', '" . $template_date . "', '" . $ipaddr . "', '" . $ipaddr . "', '" . $database -> dbescape( $words_templates[ 'IMPORTED_FROM_DIRECTORY' ] ) . "')" );
					echo " " . $words_templates[ 'IMPORTING' ] . " <br />";
				}
			}
		}
	}
	
	echo "<br />" . $words_templates[ 'UPDATE_COMPLETE' ];
	$html -> makemainfooter();
}
?>